with Ada.Command_Line;
with Ada.Integer_Text_IO;
with Ada.Text_IO;

use Ada.Command_Line;
use Ada.Integer_Text_IO;
use Ada.Text_IO;

procedure Box_Geometry is
    Num_Arguments         : constant Natural := 3;
    Length_Argument_Index : constant Natural := 1;
    Width_Argument_Index  : constant Natural := 2;
    Height_Argument_Index : constant Natural := 3;
    Print_Width           : constant Natural := 10;

	Length_In_CM   : Natural;
    Width_In_CM    : Natural;
    Height_In_CM   : Natural;
	Volume_In_CCM  : Natural;
	Surface_In_QCM : Natural;
begin
    if Argument_Count /= Num_Arguments then
        Put_Line(Standard_Error, 
            "Computes volume and surface for given box dimensions.");
        Put_Line(Standard_Error, "Usage: <length> <width> <height> (in cm)");
        Set_Exit_Status(Failure);
    else
        Length_In_CM := Integer'Value(Argument(Length_Argument_Index));
        Width_In_CM := Integer'Value(Argument(Width_Argument_Index));
        Height_In_CM := Integer'Value(Argument(Height_Argument_Index));

        Volume_In_CCM := Length_In_CM * Width_In_CM * Height_In_CM;
        Surface_In_QCM := 2 * ((Height_In_CM * Length_In_CM)
        	+ (Height_In_CM * Width_In_CM)
        	+ (Length_In_CM * Width_In_CM));

        Put("The volume of your box is:  ");
        Put(Item => Volume_In_CCM, Width => Print_Width);
        Put_Line(" ccm.");

        Put("The surface of your box is: ");
        Put(Item => Surface_In_QCM, Width => Print_Width);
        Put_Line(" qcm.");
    end if;
end Box_Geometry;
